module Moist
  module ActiveRecord
    module Extension
      def self.included(klass)
        klass.extend ClassMethods
      end

      module Campaigns
        extend ActiveSupport::Concern

        included do
          has_many :moist_campaign_subscribers, class_name: '::Moist::CampaignSubscriber', as: :subscriber
        end
      end

      module Users
        extend ActiveSupport::Concern

        included do
          has_many :moist_subscriptions, class_name: '::Moist::CampaignSubscriber'
        end
      end

      module ClassMethods
        def has_moist_campaigns
          include ::Moist::ActiveRecord::Extension::Campaigns
        end

        def acts_as_moist_user
          include ::Moist::ActiveRecord::Extension::Users
        end
      end
    end
  end
end
