module Moist
  class MailerRegistry
    def initialize
      @table = Hash.new
    end

    def register(mailer, action)
      @table[mailer] ||= Set.new
      @table[mailer] << action.to_s
    end

    def [](val)
      @table[val]
    end

    def enabled?(klass, action)
      @table[klass] && @table[klass].include?(action)
    end
  end
end
