module Moist
  module Models
    module CampaignSubscriber
      def self.included(klass)
        #    klass.extend ClassMethods
      end

      def current_step
        most_recent_moist_mailing
      end

      def next_step
        next_moist_mailing || raise(::Moist::CampaignComplete)
      end

      def next_mailing
        return nil unless next_step

         moist_mailings.find_by(mailer_class: next_step.mailer_class, mailer_action: next_step.mailer_action)
      end

      def next_step?
        next_moist_mailing.present?
      end

      def ready_for_next_mailing?
        return false unless next_mailing

        next_mailing.send_at < Time.current
      end

      def mail!
        next_mailing.deliver!
      end
    end
  end
end
