module Moist
  module Models
    module Mailing
      def deliver?
        raise ::Moist::MailingAlreadyDelivered if sent?

        send_at < Time.current
      end

      def sent?
        sent_at.present?
      end

      def deliver!
        ::Moist::Delivery.call(self)
      end
    end
  end
end
