module Moist
  class Scheduler
    def self.run
      new.run
    end

    def run
      ::Moist::Campaign.where(enabled: true).each do |campaign|
        campaign.subscribers.each do |subscriber|
          tick!(subscriber)
        end
      end
    end

    private

    def tick!(subscriber)
      if subscriber.ready_for_next_mail?
        subscriber.send_next_mail!
      end
    end
  end
end
