require 'moist/steps/step'

module Moist
  module Steps
    class Registry
      def initialize
        @table = Hash.new
      end

      def register(campaign_slug, mailer_class, mailer_action, options = {})
        @table[campaign_slug] ||= Set.new
        @table[campaign_slug] << Step.new(mailer_class, mailer_action, options)
      end

      def [](val)
        @table[val] || []
      end
    end
  end
end
