module Moist
  class SubscriptionManager
    attr_reader :subscriber, :user, :action
    def initialize(subscriber, user:, action:)
      @subscriber = subscriber
      @user = user
      @action = action
    end

    def call(*campaign_slugs)
      campaign_slugs.map do |campaign_slug|
        campaign = ::Moist::Campaign[campaign_slug]
        if @action == :subscribe
          ::Moist::CampaignSubscriber.first_or_create!(subscriber: subscriber, user: user, moist_campaign: campaign)
        elsif @action == :unsubscribe
          sub = ::Moist::CampaignSubscriber.find_by!(subscriber: subscriber, user: user, moist_campaign: campaign)
          sub.destroy!
          sub
        end
      end
    end
    alias to call
    alias from call
  end
end
